/*
 * # for ubuntu 11.10
 * gcc -o indicator3-applet-helper indicator3-applet-helper.c '-DGETTEXT_PACKAGE="indicator"'  -DINDICATOR_APPLET=1   '-DVERSION="0.0.1"'  '-DINDICATOR_DIR="/usr/lib/indicators3/6/"'  '-DINDICATOR_ICONS_DIR="/usr/share/libindicator/icons/"'   `pkg-config --cflags --libs gtk+-3.0 indicator3-0.4` 
 *
 * # for ubuntu 12.04
 * gcc -o indicator3-applet-helper indicator3-applet-helper.c '-DGETTEXT_PACKAGE="indicator"'  -DINDICATOR_APPLET=1   '-DVERSION="0.0.1"'  '-DINDICATOR_DIR="/usr/lib/indicators3/7/"'  '-DINDICATOR_ICONS_DIR="/usr/share/libindicator/icons/"'   `pkg-config --cflags --libs gtk+-3.0 indicator3-0.4`
 *
 */

#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "indicatorbox.c"
#include "libindicator/indicator-object.h"
#include <libido/libido.h>

int main(int argc,  char *argv[]) {
    gtk_init(&argc, &argv);
    GtkWidget *win;
    GtkWidget *menubar;
    GtkWidget *box;
    gint socket_id = 0;
    if (argc < 2) {
        return 1;
    }
    socket_id = atoi(argv[1]);
    if (socket_id < 1) {
        return 1;
    }
    printf("%d\n", socket_id);

    win = gtk_plug_new(socket_id);
    menubar = gtk_menu_bar_new();
    box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 0);
    GtkWidget *ebox = gtk_menu_bar_new();
    GtkWidget *e = gtk_menu_item_new_with_label(" ");
    gtk_container_add (GTK_CONTAINER (ebox), e);

    gtk_box_pack_start(GTK_BOX(box), menubar, 1, 1, 0);
    gtk_box_pack_start(GTK_BOX(box), ebox, 1, 1, 0);
    gtk_container_add(GTK_CONTAINER(win), box);

    ido_init();

    indbox_load_service("/usr/share/unity/indicators/com.canonical.indicator.session", menubar);
    indbox_load_service("/usr/share/unity/indicators/com.canonical.indicator.datetime", menubar);
    indbox_load_module("libprintersmenu.so", menubar);
    indbox_load_service("/usr/share/unity/indicators/com.canonical.indicator.sound", menubar);
    indbox_load_service("/usr/share/unity/indicators/com.canonical.indicator.power", menubar);
    indbox_load_service("/usr/share/unity/indicators/com.canonical.indicator.messages", menubar);
    indbox_load_service("/usr/share/unity/indicators/com.canonical.indicator.bluetooth", menubar);
    indbox_load_module("libsyncindicator.so", menubar);
    indbox_load_service("/usr/share/unity/indicators/com.canonical.indicator.keyboard", menubar);
    indbox_load_module("libapplication.so", menubar);

    gtk_widget_show_all(menubar);
    gtk_widget_show_all(box);
    gtk_widget_show_all(ebox);
    gtk_widget_show_all(e);
    gtk_widget_show_all(win);
    gtk_widget_set_size_request(win, 32, 32);
    gtk_window_resize(win, 32, 32);

    g_signal_connect(G_OBJECT(win), "destroy", gtk_main_quit, NULL);
    gtk_main();    
}
